/*********************************************************************
  All ADuC7023 library code provided by ADI, including this file, is provided
 as is without warranty of any kind, either expressed or implied.
 You assume any and all risk from the use of this code.  It is the
 responsibility of the person integrating this code into an application
 to ensure that the resulting application performs as required and is safe.

 Author        : ADI - Apps            www.analog.com/ADuC7023

 Date          : February 2009

 File          : Demo.c

 Hardware      : Applicable to ADuC7023 rev A later silicon
                 
 Description   : Uses Potentiometer on the ADuC7023 part.
 				Potentiometer controls the voltage to ADC0 chennel.
				Internal measurement of ADC0 via ADC is replicated
				on DAC1 output. This has the affect of controlling the 
				brightness of the LED, D1.
				Ensure "POT" and "DAC" switches of S1 are "On"
*********************************************************************/
#include <aduc7023.h>
unsigned int uiPLLTST = 0;
volatile unsigned int ucTest = 0;

void ADCpoweron(int);
int main(void) 
{
	POWKEY1 = 0x01;					// Configure CPU Clock for 41.78MHz, CD=0
 	POWCON = 0x00;
 	POWKEY2 = 0xF4;	

	DAC1CON = 0x13;					// Set DAC1 output to 0-AVDD range and turn DAC1 on	
	ADCpoweron(20000);				// power on ADC
	ADCCP = 0x00;	  				// select ADC channel 0
	REFCON = 0x01;					// internal 2.5V reference. 2.5V on Vref pin
	 
	while (1) 
	{
		ADCCON = 0x6A3;				// software conv., single-ended, conv. enabled
		while (!ADCSTA){}			// wait for end of conversion
		DAC1DAT = ADCDAT;			// result format is identical for DAC and ADC
	}				
				
}

void ADCpoweron(int time)
{
	ADCCON = 0x20;	 				// power-on the ADC
	while (time >=0)	  			// wait for ADC to be fully powered on
    time--;
}
